#include "bas_inc.hh"

#include <setjmp.h>
#include <list>

extern bool HandlingError;
extern jmp_buf ErrorSpot, SafeReturnToMain;
extern std::list<jmp_buf> ErrorFrameStack;
extern void* ErrorHandler, *ResumeTarget;
extern int B_ERL_VALUE, B_ERR_VALUE;

#define B_ERR_HEADER() { if(unlikely(setjmp(SafeReturnToMain))) goto *ResumeTarget; }
#define B_ERR_BEGIN() B_ERR_PUSH();switch(setjmp(ErrorSpot)) { case 0: case 1: 
#define B_ERR_OVER() case 2: ; } B_ERR_POP();

void B_RESUME_FAILTEST();
void B_ERR_PUSH();
void B_ERR_POP();
void B_RESUME();
void B_RESUME_NEXT();
void B_ERROR(BAS_INT code);

/* RESUME_TO always goes into main program */
#define B_RESUME_TO(label) \
    { B_RESUME_FAILTEST(); B_ERR_POP(); ResumeTarget=&&label; longjmp(SafeReturnToMain,1); }

#define ON_ERROR_GOTO(label) { if(likely(!HandlingError)) ErrorHandler=&&label; }
#define ON_ERROR_GOTO_NOWHERE() { ErrorHandler=0; }
